using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    /// <summary>
	/// 数据访问类:T_Repository_List_Demands 
    /// 知识库索要记录
	/// </summary>
	public partial class T_Repository_List_Demands
    {
        public T_Repository_List_Demands()
        { }
        #region  Method
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_DemandsId)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Repository_List_Demands");
            strSql.Append(" where F_DemandsId=@F_DemandsId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_DemandsId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_DemandsId;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Repository_List_Demands model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Repository_List_Demands(");
            strSql.Append("F_Deptid,F_Descript,F_LimitTime,F_File,F_Level,F_RepositoryId,F_SubmitTime,F_SubmitUser,F_CreateUser,F_CreateTime,F_IsDelete,F_DeleteUser,F_DeleteTime)");
            strSql.Append(" values (");
            strSql.Append("@F_Deptid,@F_Descript,@F_LimitTime,@F_File,@F_Level,@F_RepositoryId,@F_SubmitTime,@F_SubmitUser,@F_CreateUser,@F_CreateTime,@F_IsDelete,@F_DeleteUser,@F_DeleteTime)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Deptid", SqlDbType.Int,4),
                    new SqlParameter("@F_Descript", SqlDbType.NText),
                    new SqlParameter("@F_LimitTime", SqlDbType.DateTime),
                    new SqlParameter("@F_File", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_Level", SqlDbType.Int,4),
                    new SqlParameter("@F_RepositoryId", SqlDbType.Int,4),
                    new SqlParameter("@F_SubmitTime", SqlDbType.DateTime),
                    new SqlParameter("@F_SubmitUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_CreateUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_IsDelete", SqlDbType.Int,4),
                    new SqlParameter("@F_DeleteUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_DeleteTime", SqlDbType.DateTime)};
            parameters[0].Value = model.F_Deptid;
            parameters[1].Value = model.F_Descript;
            parameters[2].Value = model.F_LimitTime;
            parameters[3].Value = model.F_File;
            parameters[4].Value = model.F_Level;
            parameters[5].Value = model.F_RepositoryId;
            parameters[6].Value = model.F_SubmitTime;
            parameters[7].Value = model.F_SubmitUser;
            parameters[8].Value = model.F_CreateUser;
            parameters[9].Value = model.F_CreateTime;
            parameters[10].Value = model.F_IsDelete;
            parameters[11].Value = model.F_DeleteUser;
            parameters[12].Value = model.F_DeleteTime;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Repository_List_Demands model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Repository_List_Demands set ");
            strSql.Append("F_Deptid=@F_Deptid,");
            strSql.Append("F_Descript=@F_Descript,");
            strSql.Append("F_LimitTime=@F_LimitTime,");
            strSql.Append("F_File=@F_File,");
            strSql.Append("F_Level=@F_Level,");
            strSql.Append("F_RepositoryId=@F_RepositoryId,");
            strSql.Append("F_SubmitTime=@F_SubmitTime,");
            strSql.Append("F_SubmitUser=@F_SubmitUser,");
            strSql.Append("F_CreateUser=@F_CreateUser,");
            strSql.Append("F_CreateTime=@F_CreateTime,");
            strSql.Append("F_IsDelete=@F_IsDelete,");
            strSql.Append("F_DeleteUser=@F_DeleteUser,");
            strSql.Append("F_DeleteTime=@F_DeleteTime");
            strSql.Append(" where F_DemandsId=@F_DemandsId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Deptid", SqlDbType.Int,4),
                    new SqlParameter("@F_Descript", SqlDbType.NText),
                    new SqlParameter("@F_LimitTime", SqlDbType.DateTime),
                    new SqlParameter("@F_File", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_Level", SqlDbType.Int,4),
                    new SqlParameter("@F_RepositoryId", SqlDbType.Int,4),
                    new SqlParameter("@F_SubmitTime", SqlDbType.DateTime),
                    new SqlParameter("@F_SubmitUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_CreateUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_IsDelete", SqlDbType.Int,4),
                    new SqlParameter("@F_DeleteUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_DeleteTime", SqlDbType.DateTime),
                    new SqlParameter("@F_DemandsId", SqlDbType.Int,4)};
            parameters[0].Value = model.F_Deptid;
            parameters[1].Value = model.F_Descript;
            parameters[2].Value = model.F_LimitTime;
            parameters[3].Value = model.F_File;
            parameters[4].Value = model.F_Level;
            parameters[5].Value = model.F_RepositoryId;
            parameters[6].Value = model.F_SubmitTime;
            parameters[7].Value = model.F_SubmitUser;
            parameters[8].Value = model.F_CreateUser;
            parameters[9].Value = model.F_CreateTime;
            parameters[10].Value = model.F_IsDelete;
            parameters[11].Value = model.F_DeleteUser;
            parameters[12].Value = model.F_DeleteTime;
            parameters[13].Value = model.F_DemandsId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_DemandsId,string usercode)
        {

            StringBuilder strSql = new StringBuilder();
            //strSql.Append("delete from T_Repository_List_Demands ");
            strSql.Append("update T_Repository_List_Demands set ");
            strSql.Append("F_IsDelete=1,");
            strSql.Append("F_DeleteUser=@F_DeleteUser,");
            strSql.Append("F_DeleteTime=getdate() ");
            strSql.Append(" where F_DemandsId=@F_DemandsId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_DeleteUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_DemandsId", SqlDbType.Int,4)
            };
            parameters[0].Value = usercode;
            parameters[1].Value = F_DemandsId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_DemandsIdlist,string usercode)
        {
            StringBuilder strSql = new StringBuilder();
            //strSql.Append("delete from T_Repository_List_Demands ");
            strSql.Append("update T_Repository_List_Demands set ");
            strSql.Append("F_IsDelete=1,");
            strSql.Append("F_DeleteUser=" + usercode + ",");
            strSql.Append("F_DeleteTime=getdate() ");
            strSql.Append(" where F_DemandsId in (" + F_DemandsIdlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Repository_List_Demands GetModel(int F_DemandsId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 * from T_Repository_List_Demands ");
            strSql.Append(" where F_DemandsId=@F_DemandsId and F_IsDelete=0");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_DemandsId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_DemandsId;

            CallCenterApi.Model.T_Repository_List_Demands model = new CallCenterApi.Model.T_Repository_List_Demands();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }

        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Repository_List_Demands DataRowToModel(DataRow row)
        {
            Model.T_Repository_List_Demands model = new Model.T_Repository_List_Demands();
            if (row != null)
            {
                if (row["F_DemandsId"] != null && row["F_DemandsId"].ToString() != "")
                {
                    model.F_DemandsId = int.Parse(row["F_DemandsId"].ToString());
                }
                if (row["F_Deptid"] != null && row["F_Deptid"].ToString() != "")
                {
                    model.F_Deptid = int.Parse(row["F_Deptid"].ToString());
                }
                if (row["F_Descript"] != null && row["F_Descript"].ToString() != "")
                {
                    model.F_Descript = row["F_Descript"].ToString();
                }
                if (row["F_LimitTime"] != null && row["F_LimitTime"].ToString() != "")
                {
                    model.F_LimitTime = DateTime.Parse(row["F_LimitTime"].ToString());
                }
                if (row["F_File"] != null && row["F_File"].ToString() != "")
                {
                    model.F_File = row["F_File"].ToString();
                }
                if (row["F_Level"] != null && row["F_Level"].ToString() != "")
                {
                    model.F_Level = int.Parse(row["F_Level"].ToString());
                }
                if (row["F_RepositoryId"] != null && row["F_RepositoryId"].ToString() != "")
                {
                    model.F_RepositoryId = int.Parse(row["F_RepositoryId"].ToString());
                }
                if (row["F_SubmitTime"] != null && row["F_SubmitTime"].ToString() != "")
                {
                    model.F_SubmitTime = DateTime.Parse(row["F_SubmitTime"].ToString());
                }
                if (row["F_SubmitUser"] != null && row["F_SubmitUser"].ToString() != "")
                {
                    model.F_SubmitUser = row["F_SubmitUser"].ToString();
                }
                if (row["F_CreateUser"] != null && row["F_CreateUser"].ToString() != "")
                {
                    model.F_CreateUser = row["F_CreateUser"].ToString();
                }
                if (row["F_CreateTime"] != null && row["F_CreateTime"].ToString() != "")
                {
                    model.F_CreateTime = DateTime.Parse(row["F_CreateTime"].ToString());
                }
                if (row["F_IsDelete"] != null && row["F_IsDelete"].ToString() != "")
                {
                    model.F_IsDelete = int.Parse(row["F_IsDelete"].ToString());
                }
                if (row["F_DeleteUser"] != null && row["F_DeleteUser"].ToString() != "")
                {
                    model.F_DeleteUser = row["F_DeleteUser"].ToString();
                }
                if (row["F_DeleteTime"] != null && row["F_DeleteTime"].ToString() != "")
                {
                    model.F_DeleteTime = DateTime.Parse(row["F_DeleteTime"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select * ");
            strSql.Append(" FROM T_Repository_List_Demands ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" * ");
            strSql.Append(" FROM T_Repository_List_Demands ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Repository_List_Demands ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_DemandsId desc");
            }
            strSql.Append(")AS Row, T.*  from T_Repository_List_Demands T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        #endregion  Method
    }
}
